/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		åȰ¸⥸塼NIOS2_DEVѡ
 */

#include "kernel_impl.h"
#include "nios2_gcc/prc_sil.h"
#include "target_sysmod.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

#ifdef USE_UART
#include "nios2_gcc/uart.h"
#else /* USE_UART */
#include "nios2_gcc/jtag_uart.h"
#endif /* USE_UART */

/* ؿΥץȥ */
static void hw_version_check(void);

LOCAL_INLINE void
nios2_dev_putc_rom(char8 c)
{
#ifndef RC_ROM_BOOT
	while ((sil_rew_iop((void *) (JTAG_UART_PORT1_BASE + JTAG_UART_CONTROL_OFFSET)) & JTAG_UART_CONTROL_WSAPCE) == 0U) {
		/* ¹Ԥ٤ʤ */
	}
	sil_wrw_iop((void *) (JTAG_UART_PORT1_BASE + JTAG_UART_DATA_OFFSET), (uint32) c);
#else /* RC_ROM_BOOT */
	volatile int cnt = 0;
	static boolean enable = TRUE;
	if (enable == TRUE) {
		while ((sil_rew_iop((void *) (JTAG_UART_PORT1_BASE + JTAG_UART_CONTROL_OFFSET)) & JTAG_UART_CONTROL_WSAPCE) == 0U) {
			/* ¹Ԥ٤ʤ */
			if(cnt++ == 2000000){
				enable = FALSE;
				break;
			}
		}
		sil_wrw_iop((void *) (JTAG_UART_PORT1_BASE + JTAG_UART_DATA_OFFSET), (uint32) c);
	}
#endif /* RC_ROM_BOOT */
}


/*
 *  ʸν
 */
void
target_fput_str(const char8 *c)
{
	while (*c != '\0') {
		nios2_dev_putc_rom(*c);
		c++;
	}
	nios2_dev_putc_rom('\n');
}

/*
 *  Сå
 */
static void
hw_version_check(void)
{
	/* ǧ */
	if (sil_rew_iop((void *) (SYSVER_NUM_CORE)) != TNUM_HWCORE) {
		target_fput_str("Number of core is mismatch!!");
		while (1) {
		}
	}

	if (sil_rew_iop((void *) (SYSVER_MAJOR_VAR)) != MAJOR_VAR) {
		target_fput_str("Hardware Major version is mismatch!!");
		while (1) {
		}
	}
}
void
target_hardware_initialize(void)
{
	/*
	 *  ϡɥСγǧ
	 */
	hw_version_check();

	prc_hardware_initialize();
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  Nios2¸ν
	 */
	prc_initialize();

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼Υ
	 */
	trace_dump(&target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  Nios2¸νλ
	 */
	prc_terminate();

#ifdef ENABLE_RETURN_MAIN
	kerflg = FALSE;
	except_nest_cnt = 0U;
	nested_lock_os_int_cnt = 0U;
	sus_all_cnt = 0U;
	sus_all_cnt_ctx = 0U;
	sus_os_cnt = 0U;
	sus_os_cnt_ctx = 0U;

	Asm("movia r2, _ostkpt");
	Asm("ldw   sp, 0(r2)");
	Asm("call  main");
#endif /* ENABLE_RETURN_MAIN */

	while (1) {
	}
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char8 c)
{
	nios2_dev_putc_rom(c);
}
